class BarGraph {
  float bar_xdataMin = 0;
  float bar_xdataMax = 0; 
  float bar_xvolumeInterval = 0;
  float bar_xvolumeIntervalMinor = 0;
  float bar_plotX1 = 0; 
  float bar_plotY1 = 0; 
  float bar_plotX2 = 0;
  float bar_plotY2 = 0; 

  // Constructor
  BarGraph (float _bar_xdataMin, float _bar_xdataMax, float _bar_xvolumeInterval, float _bar_xvolumeIntervalMinor, 
    float _bar_plotX1, float _bar_plotY1, float _bar_plotX_W, float _bar_plotY_W) {
    bar_xdataMin = _bar_xdataMin;
    bar_xdataMax = _bar_xdataMax;
    bar_xvolumeInterval = _bar_xvolumeInterval;
    bar_xvolumeIntervalMinor = _bar_xvolumeIntervalMinor;
    bar_plotX1 = _bar_plotX1;
    bar_plotY1 = _bar_plotY1;
    bar_plotX2 = _bar_plotX1+_bar_plotX_W;
    bar_plotY2 = _bar_plotY1+_bar_plotY_W;
  }

  void bar_draw(float _data, int _divisor, float _index) {

    colorMode(HSB);

    for (int i = 0; i <= 200; i++) {
      if (i <_data*_divisor/_index) {  
        int c = 255 * i / _divisor;
        stroke(200-c, 200, 200);
        line(bar_plotX1+i, bar_plotY2-1, bar_plotX1+i, bar_plotY1+1);
      }
    }
    fill(0);
    textSize(13);
    textLeading(15);
    textAlign(LEFT, CENTER);
    text(nf(_data, 2, 1), bar_plotX2+5, bar_plotY1+10);
  }

  void bar_xdrawVolumeLabels() {
    fill(0);
    textSize(8);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1);

    for (float v = bar_xdataMin; v <= bar_xdataMax; v += bar_xvolumeInterval) {
      if (v % bar_xvolumeInterval == 0) {     // If a tick mark
        float x = map(v, bar_xdataMin, bar_xdataMax, bar_plotX1, bar_plotX2);  
        if (v % bar_xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == bar_xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == bar_xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v), x + textOffset, bar_plotY2 + 16);
          line(x, bar_plotY2, x, bar_plotY2+4);     // Draw major tick
        } else {
          line(x, bar_plotY1 + 2, x, bar_plotY1 + 6);     // Draw minor tick
        }
      }
    }
  }

  void bar_drawxLabels() {
    fill(0);
    stroke(0);
    strokeWeight(1);

    for (float v = bar_xdataMin; v <= bar_xdataMax; v += bar_xvolumeIntervalMinor) {
      if (v % bar_xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, bar_xdataMin, bar_xdataMax, bar_plotX1, bar_plotX2);  
        if (v % bar_xvolumeInterval == 0) {        // If a major tick mark
          if (v == bar_xdataMin) {
          } else if (v == bar_xdataMax) {
          }
          line(x, bar_plotY2+2, x, bar_plotY2+6);     // Draw major tick
        }
      }
    }
  }

  void backBar() {
    fill(#D8D8D8);
    noStroke();
    rect(bar_plotX1, bar_plotY1, bar_plotX2, bar_plotY2);
  } 

  void barLabels(String _label) {
    fill(0);
    textSize(13);
    textLeading(15);

    textAlign(CENTER, CENTER);
    text(_label, bar_plotX1-60, bar_plotY1+10);
    textAlign(CENTER, CENTER);
  }
}